/*!
 * @kevinoo91/chartjs-plugin-streaming v2.1.0
 * https://github.com/kevinoo/chartjs-plugin-streaming#readme
 * (c) 2021 Akihiko Kusanagi
 * Released under the MIT license
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t(require("chart.js"),require("chartjs-adapter-moment")):"function"==typeof define&&define.amd?define(["chart.js","chartjs-adapter-moment"],t):(e="undefined"!=typeof globalThis?globalThis:e||self).ChartStreaming=t(e.Chart)}(this,(function(e){"use strict";function t(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var a=t(e),i=a.default.helpers,r=function(){if("undefined"!=typeof window)return window.cancelAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame||window.oCancelAnimationFrame||window.msCancelAnimationFrame||function(e){return window.clearTimeout(e)}}(),o={startFrameRefreshTimer:function(e,t){if(!e.frameRequestID){var a=function(){t(),e.frameRequestID=i.requestAnimFrame.call(window,a)};e.frameRequestID=i.requestAnimFrame.call(window,a)}},stopFrameRefreshTimer:function(e){var t=e.frameRequestID;t&&(r.call(window,t),delete e.frameRequestID)}},n=a.default.helpers,s=void 0!==a.default.registry.scales.items.time?a.default.registry.scales.items.time:void 0;function l(e,t){if(n.isNullOrUndef(t))return NaN;if(("number"==typeof t||t instanceof Number)&&!isFinite(t))return NaN;if(t)if(e.isHorizontal()){if(void 0!==t.x)return l(e,t.x)}else if(void 0!==t.y)return l(e,t.y);return t}function u(e,t){if(n.isNullOrUndef(t))return null;let a=e.options.time,i=function(e,t){let a=e._adapter,i=e.options.time,r=i.parser,o=r||i.format,n=t;return"function"==typeof r&&(n=r(n)),("number"==typeof n||n instanceof Number)&&isFinite(n)||(n="string"==typeof o?a.parse(n,o):a.parse(n)),null!==n?+n:(r||"function"!=typeof o||(n=o(t),("number"==typeof n||n instanceof Number)&&isFinite(n)||(n=a.parse(n))),n)}(e,l(e,t));return null===i||a.round&&(i=+e._adapter.startOf(i,a.round)),i}function d(e,t){let a=e.options.realtime,i=e.chart.options.plugins.streaming;if("onRefresh"!==t)return n.valueOrDefault(a[t],i[t]);console.dir({key:t,scale:e,"realtimeOpts[onRefresh]":a.onRefresh,"streamingOpts[onRefresh]":i.onRefresh,"realtimeOpts[delay]":a.delay,"streamingOpts[delay]":i.delay})}var f=["pointBackgroundColor","pointBorderColor","pointBorderWidth","pointRadius","pointRotation","pointStyle","pointHitRadius","pointHoverBackgroundColor","pointHoverBorderColor","pointHoverBorderWidth","pointHoverRadius","backgroundColor","borderColor","borderSkipped","borderWidth","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth","hoverRadius","hitRadius","radius","rotation"];function p(e){let t=e.realtime,a=t.refreshTimerID;a&&(clearInterval(a),delete t.refreshTimerID,delete t.refreshInterval)}function m(e){let t=e.realtime,a=d(e,"refresh");void 0===t.refreshTimerID&&(t.refreshTimerID=setInterval((function(){let a=d(e,"refresh");!function(e){let t,a,i,r,o,s,l,u=e.chart,p=e.id,m=d(e,"duration"),c=d(e,"delay"),h=d(e,"ttl"),y=d(e,"pause"),g=e.max,v=Date.now()-(isNaN(h)?m+c:h);try{void 0!==e.chart.config._config.options.scales[e.id].realtime.onRefresh&&(0,e.chart.config._config.options.scales[e.id].realtime.onRefresh)(u)}catch(t){throw Error("Error to access to the onRefresh callback in config.options.scales["+e.id+'].realtime.onRefresh"')}u.data.datasets.forEach((function(d,m){if(t=u.getDatasetMeta(m),p===t.xAxisID||p===t.yAxisID){if(a=d.data,i=a.length,y){for(r=0;r<i&&e._getTimeForIndex(r,m)<g;++r);o=r+2}else o=0;for(r=o;r<i&&e._getTimeForIndex(r,m)<=v;++r);s=r-o,isNaN(h)&&(s=Math.max(s-2,0)),a.splice(o,s),f.forEach((function(e){d.hasOwnProperty(e)&&n.isArray(d[e])&&d[e].splice(o,s)})),n.each(d.datalabels,(function(e){n.isArray(e)&&e.splice(o,s)})),"object"!=typeof a[0]&&(l={start:o,count:s})}})),l&&u.data.labels.splice(l.start,l.count),u.update({preservation:!0})}(e),t.refreshInterval===a||isNaN(a)||(p(e),m(e))}),a)),t.refreshInterval=a}var c={data:["x","controlPointPreviousX","controlPointNextX"],dataset:["x"],tooltip:["x","caretX"]},h={data:["y","controlPointPreviousY","controlPointNextY"],dataset:["y"],tooltip:["y","caretY"]};function y(e,t,a){let i,r,o=e._start||{},n=e._view||{},s=e._model||{};for(i=0,r=t.length;i<r;++i){let e=t[i];o.hasOwnProperty(e)&&(o[e]-=a),n.hasOwnProperty(e)&&n!==o&&(n[e]-=a),s.hasOwnProperty(e)&&s!==n&&(s[e]-=a)}}class g extends s{init(){let e=this;s.prototype.init.apply(e,arguments),("time"!==e.options.type||e.chart.options.plugins.streaming)&&(e.realtime=e.realtime||{},m(e))}update(){let e=this,t=e.realtime;return"time"!==e.options.type||e.chart.options.plugins.streaming?(d(e,"pause")?o.stopFrameRefreshTimer(t):(o.startFrameRefreshTimer(t,(function(){!function(e){let t,a,i,r,o,s,l,u=e.chart,f=e.realtime,p=d(e,"duration"),m=d(e,"delay"),g=e.id,v=u._active,x=Date.now();e.isHorizontal()?(t=e.width,a=c):(t=e.height,a=h),i=t*(x-f.head)/p,e.options.ticks.reverse&&(i=-i),n.each(u.data.datasets,(function(e,t){if(r=u.getDatasetMeta(t),g===r.xAxisID||g===r.yAxisID){for(o=r.data||[],s=0,l=o.length;s<l;++s)y(o[s],a.data,i);r.dataset&&y(r.dataset,a.dataset,i)}})),v&&v[0]&&(r=u.getDatasetMeta(v[0]._datasetIndex),g!==r.xAxisID&&g!==r.yAxisID||y(tooltip,a.tooltip,i)),e.max=e._table[1].time=x-m,e.min=e._table[0].time=e.max-p,f.head=x}(e)})),t.head=Date.now()),s.prototype.update.apply(e,arguments)):s.prototype.update.apply(e,arguments)}buildTicks(){let e=this,t=e.options;if("time"===t.type&&!e.chart.options.plugins.streaming)return s.prototype.buildTicks.apply(e,arguments);let a,i=t.time,r=t.ticks.major,o=d(e,"duration"),l=d(e,"delay"),u=d(e,"refresh"),f=t.bounds,p=t.distribution,m=t.offset,c=i.min,h=i.max,y=r.enabled,g=e.realtime.head-l,v=g-o,x=[g+u,g];return t.bounds=void 0,t.distribution="linear",t.offset=!1,i.min=-1e15,i.max=1e15,r.enabled=!0,Object.defineProperty(e,"min",{get:function(){return v},set:n.noop}),Object.defineProperty(e,"max",{get:function(){return x.shift()},set:n.noop}),a=s.prototype.buildTicks.apply(e,arguments),delete e.min,delete e.max,e.min=v,e.max=g,t.bounds=f,t.distribution=p,t.offset=m,i.min=c,i.max=h,r.enabled=y,e._table=[{time:v,pos:0},{time:g,pos:1}],a}fit(){let e=this,t=e.options;s.prototype.fit.apply(e,arguments),("time"!==t.type||e.chart.options.plugins.streaming)&&t.ticks.display&&t.display&&e.isHorizontal()&&(e.paddingLeft=3,e.paddingRight=3,e._handleMargins())}draw(e){let t=this,a=t.chart;if("time"===t.options.type&&!a.options.plugins.streaming)return void s.prototype.draw.apply(t,arguments);let i=t.ctx;var r=t.isHorizontal()?{left:e.left,top:0,right:e.right,bottom:a.height}:{left:0,top:e.top,right:a.width,bottom:e.bottom};n.clipArea(i,r),s.prototype.draw.apply(t,arguments),n.unclipArea(i)}destroy(){let e=this;("time"!==e.options.type||e.chart.options.plugins.streaming)&&(o.stopFrameRefreshTimer(e.realtime),p(e))}_getTimeForIndex(e,t){let a,i=this,r=i.chart.data,o=r.datasets[t][e];return n.isNullOrUndef(o)&&(a=i.chart.data.datasets[t].data[e],o=n.isObject(a)?u(i,a):u(i,r.labels[e])),o}}g.id="realtime",g.defaults={position:"bottom",distribution:"linear",bounds:"data",adapters:{},time:{parser:!1,unit:!1,round:!1,displayFormat:!1,isoWeekday:!1,minUnit:"millisecond",displayFormats:{millisecond:"h:mm:ss.SSS a",second:"h:mm:ss a",minute:"h:mm a",hour:"hA",day:"MMM D",week:"ll",month:"MMM YYYY",quarter:"[Q]Q - YYYY",year:"YYYY"}},realtime:{},ticks:{autoSkip:!1,source:"auto",major:{enabled:!0}}},a.default.registry.addScales(g);var v=a.default.helpers;function x(e){var t,i,r,o,n=this,s=e&&e.preservation;s&&(t=n.tooltip,i=n.lastActive,r=t._lastActive,n._bufferedRender=!0),a.default.prototype.update.apply(n,arguments),s&&(n._bufferedRender=!1,n._bufferedRequest=null,n.lastActive=i,t._lastActive=r,n.animating&&a.default.animationService.animations.forEach((function(e){e.chart===n&&n.render({duration:16.66*(e.numSteps-e.currentStep)})})),t._active&&t.update(!0),(o=n.streaming.lastMouseEvent)&&n.eventHandler(o))}a.default.defaults.plugins.streaming={duration:1e4,delay:0,frameRate:30,refresh:1e3,onRefresh:null,pause:!1,ttl:void 0};var b={id:"streaming",beforeInit:function(e){var t=e.streaming=e.streaming||{},a=t.canvas=e.canvas,i=t.mouseEventListener=function(a){var i=v.getRelativePosition(a,e);t.lastMouseEvent={type:"mousemove",chart:e,native:a,x:i.x,y:i.y}};a.addEventListener("mousedown",i),a.addEventListener("mouseup",i)},afterInit:function(e){e.update=x,e.resetZoom&&a.default.Zoom.updateResetZoom(e)},beforeUpdate:function(e){var t=e.options,a=t.scales;return a&&[a.x,a.y].forEach((function(e){"realtime"!==e.type&&"time"!==e.type||(t.elements.line.capBezierPoints=!1)})),!0},afterUpdate:function(e,t){var a=e.streaming,i=!0;v.each(e.scales,(function(e){e instanceof g&&(i&=v.valueOrDefault(e.options.realtime.pause,t.pause))})),i?o.stopFrameRefreshTimer(a):o.startFrameRefreshTimer(a,(function(){!function(e){var t=e.streaming,a=e.options.plugins.streaming.frameRate,i=1e3/(Math.max(a,0)||30),r=t.lastDrawn+i||0,o=Date.now(),n=t.lastMouseEvent;r<=o&&(e.animating||e.draw(),n&&e.eventHandler(n),t.lastDrawn=r+i>o?r:o)}(e)}))},beforeDatasetDraw:function(e,t){var a=t.meta,i=e.chartArea,r={left:0,top:0,right:e.width,bottom:e.height};return a.xAxisID&&a.controller.getScaleForId(a.xAxisID)instanceof g&&(r.left=i.left,r.right=i.right),a.yAxisID&&a.controller.getScaleForId(a.yAxisID)instanceof g&&(r.top=i.top,r.bottom=i.bottom),v.clipArea(e.ctx,r),!0},afterDatasetDraw:function(e){v.unclipArea(e.ctx)},beforeEvent:function(e,t){var a=e.streaming;return"mousemove"===t.type?a.lastMouseEvent=t:"mouseout"===t.type&&delete a.lastMouseEvent,!0},destroy:function(e){var t=e.streaming,a=t.canvas,i=t.mouseEventListener;o.stopFrameRefreshTimer(t),a.removeEventListener("mousedown",i),a.removeEventListener("mouseup",i),v.each(e.scales,(function(e){e instanceof g&&e.destroy()}))}},w=a.default.helpers,D=a.default.Zoom=a.default.Zoom||{};function R(e,t){if(e.scaleAxes&&e.rangeMax&&!w.isNullOrUndef(e.rangeMax[e.scaleAxes])){var a=e.rangeMax[e.scaleAxes];t>a&&(t=a)}return t}function A(e,t){if(e.scaleAxes&&e.rangeMin&&!w.isNullOrUndef(e.rangeMin[e.scaleAxes])){var a=e.rangeMin[e.scaleAxes];t<a&&(t=a)}return t}return D.zoomFunctions=D.zoomFunctions||{},D.panFunctions=D.panFunctions||{},D.zoomFunctions.realtime=function(e,t,a,i){var r,o,n=e.options.realtime,s=e.chart.options.plugins.streaming,l=w.valueOrDefault(n.duration,s.duration),u=w.valueOrDefault(n.delay,s.delay),d=l*(2-t);r=e.isHorizontal()?(e.right-a.x)/(e.right-e.left):(e.bottom-a.y)/(e.bottom-e.top),o=t<1?R(i,d):A(i,d),n.duration=o,n.delay=u+r*(l-o)},D.panFunctions.realtime=function(e,t,a){var i=e.options.realtime,r=e.chart.options.plugins.streaming,o=w.valueOrDefault(i.delay,r.delay)+(e.getValueForPixel(t)-e.getValueForPixel(0));i.delay=t>0?R(a,o):A(a,o)},D.updateResetZoom=function(e){var t=e.$zoom||{_originalOptions:{}},a=e.resetZoom,i=e.update,r=function(){w.each(e.scales,(function(e){var a=e.options.realtime,i=t._originalOptions[e.id]||e.originalOptions;a&&(i?(a.duration=i.realtime.duration,a.delay=i.realtime.delay):(delete a.duration,delete a.delay))})),i.call(e,{duration:0})};e.resetZoom=function(){e.update=r,a(),e.update=i}},a.default.helpers.streaming=o,a.default.register(b),b}));
